#include "const.h"
#include "smartsprite.h"

// Constructor
SmartSprite::SmartSprite()
{
	AnimatedSprite::init(nullptr, nullptr);
	init(nullptr, nullptr);
}

// Destructor
SmartSprite::~SmartSprite()
{
	init(nullptr, nullptr);
}

// Inicializador
void SmartSprite::init(LTexture *texture, SDL_Renderer *renderer)
{
	setTexture(texture);
	setRenderer(renderer);

	setPosX(0);
	setPosY(0);
	setWidth(0);
	setHeight(0);

	setVelX(0);
	setVelY(0);
	setAccelX(0);
	setAccelY(0);

	setSpriteClip(0, 0, 0, 0);

	setEnabled(false);
	setCounter(0);

	mIsOnDestination = false;
	mDestX = 0;
	mDestY = 0;

	// El Id siempre es >=0, por lo tanto si no se le asigna Id se queda en negativo
	mId = -1;
}

// Pone a cero los elementos del objeto
void SmartSprite::reset()
{
	init(nullptr, nullptr);
}

// Obtiene el valor de la variable
bool SmartSprite::isEnabled()
{
	return mEnabled;
}

// Establece el valor de la variable
void SmartSprite::setEnabled(bool state)
{
	mEnabled = state;
}

// Obtiene el valor del contador
Uint16 SmartSprite::getCounter()
{
	return mCounter;
}

// Establece el valor del contador
void SmartSprite::setCounter(Uint16 time)
{
	mCounter = time;
}

// Establece el valor del contador
void SmartSprite::resetCounter(Uint16 time)
{
	mCounter = mCounterIni;
}

// Establece el valor de la variable
void SmartSprite::setDestX(int value)
{
	mDestX = value;
}

// Establece el valor de la variable
void SmartSprite::setDestY(int value)
{
	mDestY = value;
}

// Obtiene el valor de la variable
int SmartSprite::getDestX()
{
	return mDestX;
}

// Obtiene el valor de la variable
int SmartSprite::getDestY()
{
	return mDestY;
}

// Actualiza la posición y comprueba si ha llegado a su destino
bool SmartSprite::update()
{
	if (mEnabled)
	{
		// Actualiza las variables de posición, velocidad y animación
		AnimatedSprite::update();

		// Comprueba si se desplaza en el eje X hacia la derecha
		if ((getAccelX() > 0) || ((getAccelX() == 0) && (getVelX() > 0)))
		{
			// Comprueba si hemos llegado al destino
			if (getPosX() > mDestX)
			{
				// Lo coloca en posición
				setPosX(mDestX);

				// Lo detiene
				setVelX(0.0f);
				setAccelX(0.0f);
			}
		}

		// Comprueba si se desplaza en el eje X hacia la izquierda
		else if ((getAccelX() < 0) || ((getAccelX() == 0) && (getVelX() < 0)))
		{
			// Comprueba si hemos llegado al destino
			if (getPosX() < mDestX)
			{
				// Lo coloca en posición
				setPosX(mDestX);

				// Lo detiene
				setVelX(0.0f);
				setAccelX(0.0f);
			}
		}

		// Comprueba si se desplaza en el eje Y hacia abajo
		if ((getAccelY() > 0) || ((getAccelY() == 0) && (getVelY() > 0)))
		{
			// Comprueba si hemos llegado al destino
			if (getPosY() > mDestY)
			{
				// Lo coloca en posición
				setPosY(mDestY);

				// Lo detiene
				setVelY(0.0f);
				setAccelY(0.0f);
			}
		}
		// Comprueba si se desplaza en el eje Y hacia arriba
		else if ((getAccelY() < 0) || ((getAccelY() == 0) && (getVelY() < 0)))
		{
			// Comprueba si hemos llegado al destino
			if (getPosY() < mDestY)
			{
				// Lo coloca en posición
				setPosY(mDestY);

				// Lo detiene
				setVelY(0.0f);
				setAccelY(0.0f);
			}
		}

		// Comprueba si ha llegado a su destino
		if ((getPosX() == mDestX) && (getPosY() == mDestY))
		{
			mIsOnDestination = true;
		}
		else
		{
			mIsOnDestination = false;
		}

		// Si esta en el destino comprueba su contador
		if (mIsOnDestination)
		{
			// Si el contador es mayor que cero, lo decrementa
			if (mCounter > 0)
			{
				mCounter--;
			}
			// Si ha llegado a cero, deshabilita el objeto o manda el aviso en función de si tiene Id
			else if (mCounter == 0)
			{
				if (mId < 0)
				{
					mEnabled = false;
				}
				else
				{
					//return true;;
				}
			}
		}
	}

	return mIsOnDestination;
}

// Obtiene el valor de la variable
bool SmartSprite::isOnDestination()
{
	return mIsOnDestination;
}

// Pinta el objeto en pantalla
void SmartSprite::render()
{
	if (mEnabled)
	{
		MovingSprite::render();
	}
}

// Establece el valor de la variable
void SmartSprite::setId(int id)
{
	mId = id;
}